package io.gitlab.jfronny.inceptum.common;

import io.gitlab.jfronny.gson.stream.JsonReader;
import io.gitlab.jfronny.gson.stream.JsonWriter;

public class GsonPreset {
    public static class Config {
        public static void configure(JsonReader reader) {
            reader.setSerializeSpecialFloatingPointValues(true);
            reader.setLenient(true);
        }

        public static void configure(JsonWriter writer) {
            writer.setSerializeNulls(true);
            writer.setSerializeSpecialFloatingPointValues(true);
            writer.setLenient(true);
            writer.setIndent("    ");
            writer.setOmitQuotes(true);
        }
    }

    public static class Api {
        public static void configure(JsonReader reader) {
            reader.setSerializeSpecialFloatingPointValues(true);
            reader.setLenient(true);
        }

        public static void configure(JsonWriter writer) {
            writer.setSerializeNulls(false);
            writer.setSerializeSpecialFloatingPointValues(true);
            writer.setLenient(false);
        }
    }
}
